BFS(八数码) POJ 1077 || HDOJ 1043 Eight

题目传送门1 2

题意:从无序到有序移动的方案,即最后成1 2 3 4 5 6 7 8 0

分析:八数码经典问题。POJ是一次,HDOJ是多次。因为康托展开还不会,也写不了什么,HDOJ需要从最后的状态逆向搜索,这样才不会超时。判重康托展开,哈希也可。

POJ

//#include <bits/stdc++.h>
#include<iostream>
#include<algorithm>
#include<string>
#include<stack>
#include<queue>
#include <cstring>
#include<map>
#include<stdio.h>
#include<stdlib.h>
#include<ctype.h>
#include<time.h>
#include<math.h>
using namespace std;

const int N = 362880 + 5;
const int MOD = 1e6 + 7;
int dx[4] = {-1, 1, 0, 0};
int dy[4] = {0, 0, -1, 1};
char dir[4] = {‘u‘, ‘d‘, ‘l‘, ‘r‘};
struct Point	{
	int s, d;
	string str;
	Point () {}
	Point (int s, int d, string str) : s (s), d (d), str (str) {}
};
struct Hash_table	{
	struct Edge	{
		int v, nex;
	}edge[MOD];
	int head[MOD], e;
	void init(void)	{
		memset (head, -1, sizeof (head));
		e = 0;
	}
	bool insert(int x)	{
		int u = (x % MOD + MOD) % MOD;
		for (int i=head[u]; ~i; i=edge[i].nex)	{
			if (edge[i].v == x)	return false;
		}
		edge[e].v = x;	edge[e].nex = head[u];
		head[u] = e++;
		return true;
	}
}ha;
int vis[N], fact[9];

void decode(int x, int *b)	{
	for (int i=8; i>=0; --i)	{
		b[i] = x % 10;
		x /= 10;
	}
}

int encode(int *b)	{
	int ret = 0;
	for (int i=0; i<9; ++i)	{
		ret = ret * 10 + b[i];
	}
	return ret;
}

int find_0(int *b)	{
	for (int i=0; i<9; ++i)	{
		if (b[i] == 0)	return i;
	}
	return -1;
}

bool check(int x, int y)	{
	if (x < 0 || x >= 3 || y < 0 || y >= 3)	return false;
	else	return true;
}

void print(int *b)	{
	for (int i=0; i<9; ++i)	{
		printf ("%d ", b[i]);
		if (i == 2 || i == 5 || i == 8)	puts ("");
	}
}

void init(void)	{
	fact[0] = 1;
	for (int i=1; i<9; ++i)	fact[i] = fact[i-1] * i;
	memset (vis, false, sizeof (vis));
}

bool can_insert(int *b)	{
	int code = 0;
	for (int i=0; i<9; ++i)	{
		int cnt = 0;
		for (int j=i+1; j<9; ++j)	if (b[j] < b[i])	cnt++;
		code += fact[8-i] * cnt;
	}
	if (vis[code])	return false;
	else	{
		vis[code] = true;
		return true;
	}
}

void BFS(int *a)	{
	init ();
	int ans[9] = {1, 2, 3, 4, 5, 6, 7, 8, 0};
	int s = encode (a);
	queue<Point> que;	que.push (Point (s, 0, ""));
	while (!que.empty ())	{
		Point u = que.front ();	que.pop ();
		int b[9];
		decode (u.s, b);
		if (memcmp (ans, b, sizeof (b)) == 0)	{
			int len = u.str.length ();
			for (int i=0; i<len; ++i)	{
				printf ("%c", u.str[i]);
			}
			puts ("");
			return ;
		}
		int p = find_0 (b);
		int x = p / 3, y = p % 3;
		for (int i=0; i<4; ++i)	{
			int tx = x + dx[i], ty = y + dy[i];
			if (!check (tx, ty))	continue;
			int p2 = tx * 3 + ty;
			int t[9];
			memcpy (t, b, sizeof (b));
			t[p] = t[p2];	t[p2] = 0;
			int v = encode (t);
			//if (!ha.insert (v))	continue;
			if (!can_insert (t))	continue;
			que.push (Point (v, u.d + 1, u.str + dir[i]));
		}
	}
	puts ("unsolvable");
}

int main(void)	{
	char c[9];
	int a[9];
	while (scanf ("%c %c %c %c %c %c %c %c %c", &c[0], &c[1], &c[2], &c[3], &c[4], &c[5], &c[6], &c[7], &c[8]) == 9)	{
		for (int i=0; i<9; ++i)	{
			if (c[i] >= ‘1‘ && c[i] <= ‘9‘)	{
				a[i] = c[i] - ‘0‘;
			}
			else	a[i] = 0;
		}
		BFS (a);
	}

	return 0;
}

  

HDOJ

#include <bits/stdc++.h>
using namespace std;

const int N = 362880 + 5;
int dx[4] = {-1, 1, 0, 0};
int dy[4] = {0, 0, -1, 1};
char dir[4] = {‘d‘, ‘u‘, ‘r‘, ‘l‘};
struct Point	{
	int s;
	int b[9];
};
struct Ans	{
	char dir;
	int fa;
}ans[N];
int fact[9];

int find_0(int *b)	{
	for (int i=0; i<9; ++i)	{
		if (b[i] == 9)	return i;
	}
	return -1;
}

bool check(int x, int y)	{
	if (x < 0 || x >= 3 || y < 0 || y >= 3)	return false;
	else	return true;
}

void init(void)	{
	fact[0] = 1;
	for (int i=1; i<9; ++i)	fact[i] = fact[i-1] * i;
	for (int i=0; i<N; ++i)	ans[i].fa = -1;
}

int Cantor(int *b)	{
	int code = 0;
	for (int i=0; i<9; ++i)	{
		int cnt = 0;
		for (int j=i+1; j<9; ++j)	if (b[j] < b[i])	cnt++;
		code += fact[8-i] * cnt;
	}
	return code;
}

void BFS()	{
	init ();
	Point sta;
	for (int i=0; i<9; ++i)	{
		sta.b[i] = i + 1;
	}
	sta.s = 0;	ans[sta.s].fa = 0;
	queue<Point> que;	que.push (sta);
	while (!que.empty ())	{
		Point u = que.front ();	que.pop ();
		int p = find_0 (u.b);
		int x = p / 3, y = p % 3;
		for (int i=0; i<4; ++i)	{
			Point v = u;
			int tx = x + dx[i], ty = y + dy[i];
			if (!check (tx, ty))	continue;
			int p2 = tx * 3 + ty;
			swap (v.b[p], v.b[p2]);
			v.s = Cantor (v.b);
			if (ans[v.s].fa != -1)	continue;
			ans[v.s].dir = dir[i];
			ans[v.s].fa = u.s;
			que.push (v);
		}
	}
}

int main(void)	{
	BFS ();
	char c[55];
	int a[9];
	while (gets (c))	{
		int j = 0;
		for (int i=0; c[i]; ++i)	{
			if (c[i] >= ‘0‘ && c[i] <= ‘8‘)	{
				a[j++] = c[i] - ‘0‘;
			}
			else if (c[i] == ‘x‘)	a[j++] = 9;
		}
		int s = Cantor (a);
		if (ans[s].fa == -1)	puts ("unsolvable");
		else	{
			while (s != 0)	{
				printf ("%c", ans[s].dir);
				s = ans[s].fa;
			}
			puts ("");
		}
	}

	return 0;
}

  

时间: 2024-10-12 14:23:03

BFS(八数码) POJ 1077 || HDOJ 1043 Eight的相关文章

HDU 1043 Eight (BFS&#183;八数码&#183;康托展开)

题意  输出八数码问题从给定状态到12345678x的路径 用康托展开将排列对应为整数  即这个排列在所有排列中的字典序  然后就是基础的BFS了 #include <bits/stdc++.h> using namespace std; const int N = 5e5, M = 9; int x[4] = { -1, 1, 0, 0}; int y[4] = {0, 0, -1, 1}; int fac[] = {1, 1, 2, 6, 24, 120, 720, 5040, 40320

HDU - 1043 - Eight / POJ - 1077 - Eight

先上题目: Eight Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 11243    Accepted Submission(s): 3022Special Judge Problem Description The 15-puzzle has been around for over 100 years; even if you

HDU 1043 POJ 1077 八数码问题

以下内容转载自:http://www.cnblogs.com/goodness/archive/2010/05/04/1727141.html 八数码的八境界 研究经典问题,空说不好,我们拿出一个实际的题目来演绎.八数码问题在北大在线测评系统中有一个对应的题,题目描述如下: Eight Time Limit: 1000MS    Memory Limit: 65536K  Special Judge Description The 15-puzzle has been aroundfor ove

poj 1077 八数码(BFS+康托展开)

1 /* 2 题意:八数码问题,给出3*3的矩阵含1~8以及x,给出一个符合的解使得移动后的矩阵的顺序为1~8,最后为x 3 4 题解:BFS 5 需要用到康托展开来表示状态,不然数组无法完全表示所有状态,这样BFS就无法判断找不到解的情况(status 6 的0ms,0KB究竟是怎么做到的,简直不能想象=.=) 7 */ 8 #include <cstdio> 9 #include <cstring> 10 #include <queue> 11 #include &

HDU 1043 Eight八数码解题思路(bfs+hash 打表 IDA* 等)

题目链接 https://vjudge.net/problem/HDU-1043 经典的八数码问题,学过算法的老哥都会拿它练搜索 题意: 给出每行一组的数据,每组数据代表3*3的八数码表,要求程序复原为初始状态 思路: 参加网站比赛时拿到此题目,因为之前写过八数码问题,心中暗喜,于是写出一套暴力bfs+hash,结果TLE呵呵 思路一:bfs+hash(TLE) 1 #include <cstdio> 2 #include <cstring> 3 #include <queu

HDU 1043 Eight(八数码)

p.MsoNormal { margin: 0pt; margin-bottom: .0001pt; text-align: justify; font-family: Calibri; font-size: 10.5000pt } h1 { margin-top: 5.0000pt; margin-bottom: 5.0000pt; text-align: center; font-family: 宋体; color: rgb(26,92,200); font-weight: bold; fo

Hdu 1043 Eight (八数码问题)

题目链接: http://acm.hdu.edu.cn/showproblem.php?pid=1043 题目描述: 3*3的格子,填有1到8,8个数字,还有一个x,x可以上下左右移动,问最终能否移动到12345678x的状态? hint:每一个3*3的格子从上到右,从左到右,一行一行读. 解题思路: 比较简单的八数码问题,大一暑假老师讲过,一直手懒脑懒并没有亲自尝试过.因为是多实例,先从12345678x的状态bfs出来所有可以到达的状态,并且记录下来路径.八数码最重要的就是保存状态,如果这个

HDU1043 八数码(BFS + 打表)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1043 , 康托展开 + BFS + 打表. 经典八数码问题,传说此题不做人生不完整,关于八数码的八境界:http://www.cnblogs.com/goodness/archive/2010/05/04/1727141.html 我自己是用哈希(康托展开) + BFS  + 打表过的,第三重境界. 由于一些高级的搜索现在还没学,所以目前能升级的也就是用双向BFS来做了,等过几天有心情了来做. 本文

cdoj 1380 Xiper的奇妙历险(2) [八数码问题 bfs + 预处理]

快要NOIP 2016 了,现在已经停课集训了.计划用10天来复习以前学习过的所有内容.首先就是搜索. 八数码是一道很经典的搜索题,普通的bfs就可求出.为了优化效率,我曾经用过康托展开来优化空间,甚至还用过A*来优化时间.不过这道题懒得写了,就一个普普通通的bfs,再加上一个stl 的map就水过了. 首先题目要求有多达10000组数据,依次搜索肯定是不行的,我试过用A*来写,第2组数据就会T掉,所以我们考虑用一个预处理.从末尾状态搜索所有可行的状态,并用一个map来存储答案.然后就很好写了.